<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<title>magpar: llg/mytscreatepvode.c Source File</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<link href="doxygen.css" rel="stylesheet" type="text/css"/>
</head>
<body>
<!-- Generated by Doxygen 1.6.3 -->
<div class="navigation" id="top">
  <div class="tabs">
    <ul>
      <li><a href="index.html"><span>Main&nbsp;Page</span></a></li>
      <li><a href="pages.html"><span>Related&nbsp;Pages</span></a></li>
      <li><a href="namespaces.html"><span>Namespaces</span></a></li>
      <li><a href="annotated.html"><span>Data&nbsp;Structures</span></a></li>
      <li class="current"><a href="files.html"><span>Files</span></a></li>
      <li><a href="dirs.html"><span>Directories</span></a></li>
    </ul>
  </div>
  <div class="tabs">
    <ul>
      <li><a href="files.html"><span>File&nbsp;List</span></a></li>
      <li><a href="globals.html"><span>Globals</span></a></li>
    </ul>
  </div>
  <div class="navpath"><a class="el" href="dir_ad11b878d2835527517911859427b54f.html">llg</a>
  </div>
</div>
<div class="contents">
<h1>mytscreatepvode.c</h1><a href="mytscreatepvode_8c.html">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">/*</span>
<a name="l00002"></a>00002 <span class="comment">    This file is part of magpar.</span>
<a name="l00003"></a>00003 <span class="comment"></span>
<a name="l00004"></a>00004 <span class="comment">    Copyright (C) 2002-2010 Werner Scholz</span>
<a name="l00005"></a>00005 <span class="comment"></span>
<a name="l00006"></a>00006 <span class="comment">    www:   http://www.magpar.net/</span>
<a name="l00007"></a>00007 <span class="comment">    email: magpar(at)magpar.net</span>
<a name="l00008"></a>00008 <span class="comment"></span>
<a name="l00009"></a>00009 <span class="comment">    magpar is free software; you can redistribute it and/or modify</span>
<a name="l00010"></a>00010 <span class="comment">    it under the terms of the GNU General Public License as published by</span>
<a name="l00011"></a>00011 <span class="comment">    the Free Software Foundation; either version 2 of the License, or</span>
<a name="l00012"></a>00012 <span class="comment">    (at your option) any later version.</span>
<a name="l00013"></a>00013 <span class="comment"></span>
<a name="l00014"></a>00014 <span class="comment">    magpar is distributed in the hope that it will be useful,</span>
<a name="l00015"></a>00015 <span class="comment">    but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00016"></a>00016 <span class="comment">    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the</span>
<a name="l00017"></a>00017 <span class="comment">    GNU General Public License for more details.</span>
<a name="l00018"></a>00018 <span class="comment"></span>
<a name="l00019"></a>00019 <span class="comment">    You should have received a copy of the GNU General Public License</span>
<a name="l00020"></a>00020 <span class="comment">    along with magpar; if not, write to the Free Software</span>
<a name="l00021"></a>00021 <span class="comment">    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00022"></a>00022 <span class="comment">*/</span>
<a name="l00023"></a>00023 
<a name="l00024"></a>00024 <span class="keyword">static</span> <span class="keywordtype">char</span> <span class="keyword">const</span> Id[] = <span class="stringliteral">&quot;$Id: mytscreatepvode.c 2962 2010-02-04 19:50:44Z scholz $\n\n&quot;</span>;
<a name="l00025"></a>00025 <span class="keyword">static</span> <span class="keywordtype">char</span> <span class="keyword">const</span> Td[] = <span class="stringliteral">&quot;$Today: &quot;</span> __FILE__ <span class="stringliteral">&quot;  &quot;</span> __DATE__ <span class="stringliteral">&quot;  &quot;</span>  __TIME__  <span class="stringliteral">&quot; $\n\n&quot;</span>;
<a name="l00026"></a>00026 
<a name="l00027"></a>00027 <span class="preprocessor">#include &quot;<a class="code" href="llg_8h.html">llg.h</a>&quot;</span>
<a name="l00028"></a>00028 <span class="preprocessor">#include &quot;<a class="code" href="util_8h.html">util/util.h</a>&quot;</span>
<a name="l00029"></a>00029 
<a name="l00030"></a>00030 <span class="preprocessor">#if SUNDIALS_VERSION &gt;= 230</span>
<a name="l00031"></a>00031 <span class="preprocessor"></span><span class="preprocessor">#include &quot;cvode/cvode_diag.h&quot;</span>
<a name="l00032"></a>00032 <span class="preprocessor">#include &quot;cvode/cvode_spgmr.h&quot;</span>
<a name="l00033"></a>00033 <span class="preprocessor">#else</span>
<a name="l00034"></a>00034 <span class="preprocessor"></span><span class="preprocessor">#error &quot;SUNDIALS versions lower/older than 2.3.0 are not supported&quot;</span>
<a name="l00035"></a>00035 <span class="preprocessor"></span><span class="preprocessor">#endif</span>
<a name="l00036"></a>00036 <span class="preprocessor"></span>
<a name="l00037"></a><a class="code" href="mytscreatepvode_8c.html#a809fb699daf418600ff788f3826954c9">00037</a> <span class="keywordtype">void</span>     *<a class="code" href="mytscreatepvode_8c.html#a809fb699daf418600ff788f3826954c9">cvode_mem</a>=PETSC_NULL; <span class="comment">/* data structures for PVODE */</span>
<a name="l00038"></a><a class="code" href="mytscreatepvode_8c.html#a293e1df257c757d729d4b0200626e31a">00038</a> N_Vector <a class="code" href="mytscreatepvode_8c.html#a293e1df257c757d729d4b0200626e31a">nvu</a>;        <span class="comment">/* vector for independent variable (i.e. magnetization) */</span>
<a name="l00039"></a><a class="code" href="mytscreatepvode_8c.html#aec51da788a337a7317e3b25e8a634716">00039</a> realtype <a class="code" href="checkiterationllg_8c.html#aec51da788a337a7317e3b25e8a634716">abstol</a>;     <span class="comment">/* absolute tolerance */</span>
<a name="l00040"></a><a class="code" href="mytscreatepvode_8c.html#a29c891f86d4e498ef78fe8d82ac95ea6">00040</a> realtype <a class="code" href="checkiterationllg_8c.html#a29c891f86d4e498ef78fe8d82ac95ea6">reltol</a>;     <span class="comment">/* relative tolerance */</span>
<a name="l00041"></a>00041 
<a name="l00042"></a><a class="code" href="mytscreatepvode_8c.html#a56b55de0386618edfef4220e5b7b078a">00042</a> <span class="keywordtype">int</span> <a class="code" href="mytscreatepvode_8c.html#a56b55de0386618edfef4220e5b7b078a">PVodeInit</a>(<a class="code" href="structGridData.html">GridData</a> *gdata)
<a name="l00043"></a>00043 {
<a name="l00044"></a>00044   <span class="keywordtype">int</span>          flag;
<a name="l00045"></a>00045   PetscTruth   flg;
<a name="l00046"></a>00046 
<a name="l00047"></a>00047   <a class="code" href="griddata_8h.html#a3d9da926137619fd02adb245a08536c7">MagparFunctionLogBegin</a>;
<a name="l00048"></a>00048 
<a name="l00049"></a>00049   <span class="keywordtype">char</span> str[256];
<a name="l00050"></a>00050   ierr = PetscOptionsGetString(PETSC_NULL,<span class="stringliteral">&quot;-ts_pvode_type&quot;</span>,str,256,&amp;flg);CHKERRQ(ierr);
<a name="l00051"></a>00051   <span class="keywordflow">if</span> (flg!=PETSC_TRUE) {
<a name="l00052"></a>00052     sprintf(str,<span class="stringliteral">&quot;bdf&quot;</span>);
<a name="l00053"></a>00053     PetscPrintf(PETSC_COMM_WORLD,
<a name="l00054"></a>00054       <span class="stringliteral">&quot;Option -ts_pvode_type not found, using default value: %s\n&quot;</span>,
<a name="l00055"></a>00055       str
<a name="l00056"></a>00056     );
<a name="l00057"></a>00057   }
<a name="l00058"></a>00058 
<a name="l00059"></a>00059   <span class="keywordtype">int</span> lmmn=-1;
<a name="l00060"></a>00060   ierr = PetscStrcmp(str,<span class="stringliteral">&quot;adams&quot;</span>,&amp;flg);CHKERRQ(ierr);
<a name="l00061"></a>00061   <span class="keywordflow">if</span> (flg) lmmn=CV_ADAMS;
<a name="l00062"></a>00062   ierr = PetscStrcmp(str,<span class="stringliteral">&quot;bdf&quot;</span>,&amp;flg);CHKERRQ(ierr);
<a name="l00063"></a>00063   <span class="keywordflow">if</span> (flg) lmmn=CV_BDF;
<a name="l00064"></a>00064   <span class="keywordflow">if</span> (lmmn != CV_ADAMS &amp;&amp; lmmn != CV_BDF) {
<a name="l00065"></a>00065     SETERRQ(PETSC_ERR_ARG_OUTOFRANGE,<span class="stringliteral">&quot;Unknown time integration method.\n&quot;</span>);
<a name="l00066"></a>00066   }
<a name="l00067"></a>00067   <a class="code" href="mytscreatepvode_8c.html#a809fb699daf418600ff788f3826954c9">cvode_mem</a> = CVodeCreate(lmmn,lmmn==CV_ADAMS ? CV_FUNCTIONAL : CV_NEWTON);
<a name="l00068"></a>00068   PetscPrintf(PETSC_COMM_WORLD,<span class="stringliteral">&quot;PVODE time integration method: %s\n&quot;</span>,str);
<a name="l00069"></a>00069 
<a name="l00070"></a>00070   <span class="keywordtype">int</span> maxorder;
<a name="l00071"></a>00071   ierr = PetscOptionsGetInt(PETSC_NULL,<span class="stringliteral">&quot;-maxorder&quot;</span>,(<a class="code" href="griddata_8h.html#a515706180f960b30595b607f2d734d14" title="Contains all data to control the simulations.">PetscInt</a>*)&amp;maxorder,&amp;flg);CHKERRQ(ierr);
<a name="l00072"></a>00072   <span class="keywordflow">if</span> (flg!=PETSC_TRUE) {
<a name="l00073"></a>00073     maxorder=2;
<a name="l00074"></a>00074     PetscPrintf(PETSC_COMM_WORLD,
<a name="l00075"></a>00075       <span class="stringliteral">&quot;Option -maxorder not found, using default value: %i\n&quot;</span>,
<a name="l00076"></a>00076       maxorder
<a name="l00077"></a>00077     );
<a name="l00078"></a>00078   }
<a name="l00079"></a>00079   flag=CVodeSetMaxOrd(<a class="code" href="mytscreatepvode_8c.html#a809fb699daf418600ff788f3826954c9">cvode_mem</a>,maxorder);
<a name="l00080"></a>00080 
<a name="l00081"></a>00081   PetscReal delt; <span class="comment">/* ratio between tolerance of nonlinear and linear iterations */</span>
<a name="l00082"></a>00082   ierr = PetscOptionsGetReal(PETSC_NULL,<span class="stringliteral">&quot;-ts_pvode_linear_tolerance&quot;</span>,&amp;delt,&amp;flg);CHKERRQ(ierr);
<a name="l00083"></a>00083   <span class="keywordflow">if</span> (flg!=PETSC_TRUE) {
<a name="l00084"></a>00084     delt=0.05;
<a name="l00085"></a>00085     PetscPrintf(PETSC_COMM_WORLD,
<a name="l00086"></a>00086       <span class="stringliteral">&quot;Option -ts_pvode_linear_tolerance not found, using default value: %g\n&quot;</span>,
<a name="l00087"></a>00087       delt
<a name="l00088"></a>00088     );
<a name="l00089"></a>00089   }
<a name="l00090"></a>00090   PetscPrintf(PETSC_COMM_WORLD,<span class="stringliteral">&quot;delt: %g\n&quot;</span>,delt);
<a name="l00091"></a>00091 
<a name="l00092"></a>00092   PetscReal dtime;
<a name="l00093"></a>00093   ierr = PetscOptionsGetReal(PETSC_NULL,<span class="stringliteral">&quot;-ts_dt&quot;</span>,&amp;dtime,&amp;flg);CHKERRQ(ierr);
<a name="l00094"></a>00094   <span class="keywordflow">if</span> (flg!=PETSC_TRUE) {
<a name="l00095"></a>00095     dtime = gdata-&gt;<a class="code" href="structGridData.html#ad7a22de0cb266e66e8dbcb1bb147bae8">tscale</a>*1e9/100;
<a name="l00096"></a>00096     PetscPrintf(PETSC_COMM_WORLD,
<a name="l00097"></a>00097       <span class="stringliteral">&quot;Option -ts_dt not found, using default value: %g\n&quot;</span>,
<a name="l00098"></a>00098       dtime
<a name="l00099"></a>00099     );
<a name="l00100"></a>00100   }
<a name="l00101"></a>00101 
<a name="l00102"></a>00102   PetscReal dtmin;
<a name="l00103"></a>00103   ierr = PetscOptionsGetReal(PETSC_NULL,<span class="stringliteral">&quot;-mintimestep&quot;</span>,&amp;dtmin,&amp;flg);CHKERRQ(ierr);
<a name="l00104"></a>00104   <span class="keywordflow">if</span> (flg!=PETSC_TRUE) {
<a name="l00105"></a>00105     dtmin=0.0;
<a name="l00106"></a>00106     PetscPrintf(PETSC_COMM_WORLD,
<a name="l00107"></a>00107       <span class="stringliteral">&quot;Option -mintimestep not found, using default value: %g\n&quot;</span>,
<a name="l00108"></a>00108       dtmin
<a name="l00109"></a>00109     );
<a name="l00110"></a>00110   }
<a name="l00111"></a>00111 
<a name="l00112"></a>00112   PetscReal dtmax;
<a name="l00113"></a>00113   ierr = PetscOptionsGetReal(PETSC_NULL,<span class="stringliteral">&quot;-maxtimestep&quot;</span>,&amp;dtmax,&amp;flg);CHKERRQ(ierr);
<a name="l00114"></a>00114   <span class="keywordflow">if</span> (flg!=PETSC_TRUE) {
<a name="l00115"></a>00115     dtmax=1;
<a name="l00116"></a>00116     PetscPrintf(PETSC_COMM_WORLD,
<a name="l00117"></a>00117       <span class="stringliteral">&quot;Option -maxtimestep not found, using default value: %g\n&quot;</span>,
<a name="l00118"></a>00118       dtmax
<a name="l00119"></a>00119     );
<a name="l00120"></a>00120   }
<a name="l00121"></a>00121 
<a name="l00122"></a>00122   dtime /= 1e9*gdata-&gt;<a class="code" href="structGridData.html#ad7a22de0cb266e66e8dbcb1bb147bae8">tscale</a>;
<a name="l00123"></a>00123   dtmin /= 1e9*gdata-&gt;<a class="code" href="structGridData.html#ad7a22de0cb266e66e8dbcb1bb147bae8">tscale</a>;
<a name="l00124"></a>00124   dtmax /= 1e9*gdata-&gt;<a class="code" href="structGridData.html#ad7a22de0cb266e66e8dbcb1bb147bae8">tscale</a>;
<a name="l00125"></a>00125 
<a name="l00126"></a>00126   <span class="comment">/* dtime must not be zero! otherwise PVODE does not start properly */</span>
<a name="l00127"></a>00127   dtime = dtime &lt; <a class="code" href="griddata_8h.html#a26ab586dda1b8c780aa849e457c0cbad">D_EPS</a> ? dtmin : dtime;
<a name="l00128"></a>00128   dtmin = dtmin &lt; 0 ? dtime : dtmin;
<a name="l00129"></a>00129   dtmax = dtmax &lt; 1000 ? dtmax : 1000;
<a name="l00130"></a>00130 
<a name="l00131"></a>00131   PetscPrintf(PETSC_COMM_WORLD,<span class="stringliteral">&quot;initial time step: %g ns\n&quot;</span>,dtime*gdata-&gt;<a class="code" href="structGridData.html#ad7a22de0cb266e66e8dbcb1bb147bae8">tscale</a>*1e9);
<a name="l00132"></a>00132   PetscPrintf(PETSC_COMM_WORLD,<span class="stringliteral">&quot;minimum time step: %g ns\n&quot;</span>,dtmin*gdata-&gt;<a class="code" href="structGridData.html#ad7a22de0cb266e66e8dbcb1bb147bae8">tscale</a>*1e9);
<a name="l00133"></a>00133   PetscPrintf(PETSC_COMM_WORLD,<span class="stringliteral">&quot;maximum time step: %g ns\n&quot;</span>,dtmax*gdata-&gt;<a class="code" href="structGridData.html#ad7a22de0cb266e66e8dbcb1bb147bae8">tscale</a>*1e9);
<a name="l00134"></a>00134   PetscPrintf(PETSC_COMM_WORLD,<span class="stringliteral">&quot;reduced initial time step: %g (1)\n&quot;</span>,dtime);
<a name="l00135"></a>00135   PetscPrintf(PETSC_COMM_WORLD,<span class="stringliteral">&quot;reduced minimum time step: %g (1)\n&quot;</span>,dtmin);
<a name="l00136"></a>00136   PetscPrintf(PETSC_COMM_WORLD,<span class="stringliteral">&quot;reduced maximum time step: %g (1)\n&quot;</span>,dtmax);
<a name="l00137"></a>00137 
<a name="l00138"></a>00138   flag=CVodeSetInitStep(<a class="code" href="mytscreatepvode_8c.html#a809fb699daf418600ff788f3826954c9">cvode_mem</a>,dtime);
<a name="l00139"></a>00139   flag=CVodeSetMinStep(<a class="code" href="mytscreatepvode_8c.html#a809fb699daf418600ff788f3826954c9">cvode_mem</a>,dtmin);
<a name="l00140"></a>00140   flag=CVodeSetMaxStep(<a class="code" href="mytscreatepvode_8c.html#a809fb699daf418600ff788f3826954c9">cvode_mem</a>,dtmax);
<a name="l00141"></a>00141 
<a name="l00142"></a>00142   CVodeSetFdata(<a class="code" href="mytscreatepvode_8c.html#a809fb699daf418600ff788f3826954c9">cvode_mem</a>,gdata);
<a name="l00143"></a>00143 
<a name="l00144"></a>00144   flag = CVodeMalloc(
<a name="l00145"></a>00145     <a class="code" href="mytscreatepvode_8c.html#a809fb699daf418600ff788f3826954c9">cvode_mem</a>,
<a name="l00146"></a>00146     <a class="code" href="rhsfunction_8c.html#a5e964b5572e1640d9a793c353f6a28f6">RHSfunction</a>,
<a name="l00147"></a>00147     gdata-&gt;<a class="code" href="structGridData.html#a9eb9246406e97a2a4a8a9c471b11aa2a">time</a>,
<a name="l00148"></a>00148     <a class="code" href="mytscreatepvode_8c.html#a293e1df257c757d729d4b0200626e31a">nvu</a>,
<a name="l00149"></a>00149     CV_SS,
<a name="l00150"></a>00150     <a class="code" href="checkiterationllg_8c.html#a29c891f86d4e498ef78fe8d82ac95ea6">reltol</a>,
<a name="l00151"></a>00151     &amp;<a class="code" href="checkiterationllg_8c.html#aec51da788a337a7317e3b25e8a634716">abstol</a>
<a name="l00152"></a>00152   );
<a name="l00153"></a>00153   <span class="keywordflow">if</span> (flag != CV_SUCCESS) {
<a name="l00154"></a>00154     SETERRQ1(PETSC_ERR_LIB,<span class="stringliteral">&quot;CVodeMalloc failed: %i\n&quot;</span>,flag);
<a name="l00155"></a>00155   }
<a name="l00156"></a>00156 
<a name="l00157"></a>00157   <span class="keywordtype">int</span> precon;
<a name="l00158"></a>00158   ierr = PetscOptionsGetInt(PETSC_NULL,<span class="stringliteral">&quot;-precon&quot;</span>,(<a class="code" href="griddata_8h.html#a515706180f960b30595b607f2d734d14" title="Contains all data to control the simulations.">PetscInt</a>*)&amp;precon,&amp;flg);CHKERRQ(ierr);
<a name="l00159"></a>00159   <span class="keywordflow">if</span> (flg!=PETSC_TRUE) {
<a name="l00160"></a>00160     precon=1;
<a name="l00161"></a>00161     PetscPrintf(PETSC_COMM_WORLD,
<a name="l00162"></a>00162       <span class="stringliteral">&quot;Option -precon not found, using default value: %i\n&quot;</span>,
<a name="l00163"></a>00163       precon
<a name="l00164"></a>00164     );
<a name="l00165"></a>00165   }
<a name="l00166"></a>00166   PetscPrintf(PETSC_COMM_WORLD,<span class="stringliteral">&quot;preconditioning method: %i\n&quot;</span>,precon);
<a name="l00167"></a>00167 
<a name="l00168"></a>00168   <span class="keywordflow">switch</span> (precon) {
<a name="l00169"></a>00169     <span class="keywordflow">case</span> 0:
<a name="l00170"></a>00170       PetscPrintf(PETSC_COMM_WORLD,<span class="stringliteral">&quot;preconditioning off\n&quot;</span>);
<a name="l00171"></a>00171       flag = CVDiag(<a class="code" href="mytscreatepvode_8c.html#a809fb699daf418600ff788f3826954c9">cvode_mem</a>);
<a name="l00172"></a>00172     <span class="keywordflow">break</span>;
<a name="l00173"></a>00173     <span class="keywordflow">case</span> 1:
<a name="l00174"></a>00174       <span class="comment">/* Jacobi preconditioning - use Jtimes only, if demag is zero */</span>
<a name="l00175"></a>00175       PetscPrintf(PETSC_COMM_WORLD,<span class="stringliteral">&quot;Jacobi preconditioning on\n&quot;</span>);
<a name="l00176"></a>00176 
<a name="l00177"></a>00177       <span class="keywordtype">int</span> maxl;        
<a name="l00178"></a>00178       ierr = PetscOptionsGetInt(PETSC_NULL,<span class="stringliteral">&quot;-maxl&quot;</span>,(<a class="code" href="griddata_8h.html#a515706180f960b30595b607f2d734d14" title="Contains all data to control the simulations.">PetscInt</a>*)&amp;maxl,&amp;flg);CHKERRQ(ierr);
<a name="l00179"></a>00179       <span class="keywordflow">if</span> (flg!=PETSC_TRUE) {
<a name="l00180"></a>00180         maxl=300;
<a name="l00181"></a>00181         PetscPrintf(PETSC_COMM_WORLD,
<a name="l00182"></a>00182           <span class="stringliteral">&quot;Option -maxl not found, using default value: %i\n&quot;</span>,
<a name="l00183"></a>00183           maxl
<a name="l00184"></a>00184         );
<a name="l00185"></a>00185       }
<a name="l00186"></a>00186       PetscPrintf(PETSC_COMM_WORLD,<span class="stringliteral">&quot;maxl: %i\n&quot;</span>,maxl);
<a name="l00187"></a>00187       flag = CVSpgmr(<a class="code" href="mytscreatepvode_8c.html#a809fb699daf418600ff788f3826954c9">cvode_mem</a>,PREC_LEFT,(<span class="keywordtype">int</span>)maxl);
<a name="l00188"></a>00188 
<a name="l00189"></a>00189       <span class="comment">/* initialize Jacobi preconditioning */</span>
<a name="l00190"></a>00190       ierr = <a class="code" href="precond_8c.html#a811a9e1276828ec4cf472f954d12b1fc">Precond_Init</a>(gdata);CHKERRQ(ierr);
<a name="l00191"></a>00191 
<a name="l00192"></a>00192 <span class="preprocessor">#if SUNDIALS_VERSION &gt;= 230</span>
<a name="l00193"></a>00193 <span class="preprocessor"></span>      flag = CVSpilsSetPrecType(<a class="code" href="mytscreatepvode_8c.html#a809fb699daf418600ff788f3826954c9">cvode_mem</a>,PREC_LEFT);
<a name="l00194"></a>00194       flag = CVSpilsSetGSType(<a class="code" href="mytscreatepvode_8c.html#a809fb699daf418600ff788f3826954c9">cvode_mem</a>,MODIFIED_GS);
<a name="l00195"></a>00195       flag = CVSpilsSetPreconditioner(<a class="code" href="mytscreatepvode_8c.html#a809fb699daf418600ff788f3826954c9">cvode_mem</a>,<a class="code" href="precond_8c.html#a8cdc0d7af89d96e9d57fc6c0f791331f">Precond</a>,<a class="code" href="precond_8c.html#a26a82305d86917d32992af0031acd675">PSolve</a>,gdata);
<a name="l00196"></a>00196 <span class="preprocessor">#else</span>
<a name="l00197"></a>00197 <span class="preprocessor"></span><span class="preprocessor">#error &quot;SUNDIALS versions lower/older than 2.3.0 are not supported&quot;</span>
<a name="l00198"></a>00198 <span class="preprocessor"></span><span class="preprocessor">#endif</span>
<a name="l00199"></a>00199 <span class="preprocessor"></span>      <span class="keywordflow">if</span> (gdata-&gt;<a class="code" href="structGridData.html#a776aed135c71061b20ec61cdbb39604d">VHdem</a>==PETSC_NULL) {
<a name="l00200"></a>00200 <span class="preprocessor">#if SUNDIALS_VERSION &gt;= 230</span>
<a name="l00201"></a>00201 <span class="preprocessor"></span>        flag = CVSpilsSetJacTimesVecFn(<a class="code" href="mytscreatepvode_8c.html#a809fb699daf418600ff788f3826954c9">cvode_mem</a>,<a class="code" href="precond_8c.html#a2a797df3786fb3caa3a618c1a39d2cc9">Jtimes</a>,gdata);
<a name="l00202"></a>00202 <span class="preprocessor">#else</span>
<a name="l00203"></a>00203 <span class="preprocessor"></span><span class="preprocessor">#error &quot;SUNDIALS versions lower/older than 2.3.0 are not supported&quot;</span>
<a name="l00204"></a>00204 <span class="preprocessor"></span><span class="preprocessor">#endif</span>
<a name="l00205"></a>00205 <span class="preprocessor"></span>        PetscPrintf(PETSC_COMM_WORLD,<span class="stringliteral">&quot;Hdemag off: PVODE uses Jtimes function\n&quot;</span>);
<a name="l00206"></a>00206       }
<a name="l00207"></a>00207       <span class="keywordflow">else</span> {
<a name="l00208"></a>00208         PetscPrintf(PETSC_COMM_WORLD,
<a name="l00209"></a>00209           <span class="stringliteral">&quot;Hdemag on: PVODE uses internal difference quotient approximation for Jacobian*vector\n&quot;</span>
<a name="l00210"></a>00210         );
<a name="l00211"></a>00211       }
<a name="l00212"></a>00212     <span class="keywordflow">break</span>;
<a name="l00213"></a>00213     <span class="keywordflow">case</span> 2:
<a name="l00214"></a>00214       <span class="comment">/* BBD preconditioning */</span>
<a name="l00215"></a>00215       SETERRQ(PETSC_ERR_SUP,<span class="stringliteral">&quot;Not yet implemented!\n&quot;</span>);
<a name="l00216"></a>00216     <span class="keywordflow">break</span>;
<a name="l00217"></a>00217     <span class="keywordflow">default</span>:
<a name="l00218"></a>00218       <span class="comment">/* no preconditioning */</span>
<a name="l00219"></a>00219       PetscPrintf(PETSC_COMM_WORLD,
<a name="l00220"></a>00220         <span class="stringliteral">&quot;PVODE uses internal difference quotient approximation for Jacobian*vector\n&quot;</span>
<a name="l00221"></a>00221       );
<a name="l00222"></a>00222       flag = CVDiag(<a class="code" href="mytscreatepvode_8c.html#a809fb699daf418600ff788f3826954c9">cvode_mem</a>);
<a name="l00223"></a>00223     <span class="keywordflow">break</span>;
<a name="l00224"></a>00224   }
<a name="l00225"></a>00225 
<a name="l00226"></a>00226   <span class="keywordflow">if</span> (flag == CV_SUCCESS) {
<a name="l00227"></a>00227     PetscPrintf(PETSC_COMM_WORLD,<span class="stringliteral">&quot;PVODE successfully initialized\n&quot;</span>);
<a name="l00228"></a>00228   }
<a name="l00229"></a>00229   <span class="keywordflow">else</span> {
<a name="l00230"></a>00230     SETERRQ(PETSC_ERR_MEM,<span class="stringliteral">&quot;CVSpgmr failed.\n&quot;</span>);
<a name="l00231"></a>00231   }
<a name="l00232"></a>00232 
<a name="l00233"></a>00233   <a class="code" href="griddata_8h.html#a8491466d8534a33d7163f5ea747e8210">MagparFunctionLogReturn</a>(0);
<a name="l00234"></a>00234 }
<a name="l00235"></a>00235 
<a name="l00236"></a>00236 
<a name="l00237"></a><a class="code" href="mytscreatepvode_8c.html#a4ca0e9d74cde3d8e01ad9701426444da">00237</a> <span class="keywordtype">int</span> <a class="code" href="mytscreatepvode_8c.html#a4ca0e9d74cde3d8e01ad9701426444da">PVodeReInit</a>(<a class="code" href="structGridData.html">GridData</a> *gdata)
<a name="l00238"></a>00238 {
<a name="l00239"></a>00239   <a class="code" href="griddata_8h.html#a4e81d68a7df0ff55ea65b46253e07552">MagparFunctionInfoBegin</a>;
<a name="l00240"></a>00240 
<a name="l00241"></a>00241 <span class="preprocessor">#if 1</span>
<a name="l00242"></a>00242 <span class="preprocessor"></span>
<a name="l00243"></a>00243   <span class="comment">/* TODO: remove this section between VecGet/RestoreArray after sufficient testing */</span>
<a name="l00244"></a>00244 
<a name="l00245"></a>00245   PetscReal *tmp;
<a name="l00246"></a>00246   ierr = VecGetArray(gdata-&gt;<a class="code" href="structGridData.html#aa8ed194b67f1446b9c299028c1ed0692">M</a>,&amp;tmp);CHKERRQ(ierr);
<a name="l00247"></a>00247 
<a name="l00248"></a>00248 <span class="preprocessor">#ifdef UNIPROC</span>
<a name="l00249"></a>00249 <span class="preprocessor"></span>  assert(tmp==NV_DATA_S(<a class="code" href="mytscreatepvode_8c.html#a293e1df257c757d729d4b0200626e31a">nvu</a>));
<a name="l00250"></a>00250 <span class="preprocessor">#else</span>
<a name="l00251"></a>00251 <span class="preprocessor"></span>  assert(tmp==NV_DATA_P(<a class="code" href="mytscreatepvode_8c.html#a293e1df257c757d729d4b0200626e31a">nvu</a>));
<a name="l00252"></a>00252 <span class="preprocessor">#endif</span>
<a name="l00253"></a>00253 <span class="preprocessor"></span>
<a name="l00254"></a>00254   ierr = VecRestoreArray(gdata-&gt;<a class="code" href="structGridData.html#aa8ed194b67f1446b9c299028c1ed0692">M</a>,&amp;tmp);CHKERRQ(ierr);
<a name="l00255"></a>00255 
<a name="l00256"></a>00256   <span class="comment">/* renormalize M since we just reinitialized PVODE */</span>
<a name="l00257"></a>00257   <a class="code" href="renormvec_8c.html#abba3d002260d6e3e062ac69a80300aa4">RenormVec</a>(gdata-&gt;<a class="code" href="structGridData.html#aa8ed194b67f1446b9c299028c1ed0692">M</a>,1.0,<a class="code" href="griddata_8h.html#a26ab586dda1b8c780aa849e457c0cbad">D_EPS</a>,<a class="code" href="griddata_8h.html#a68d169e5b90cf721678bc7ab0f964a99">ND</a>);
<a name="l00258"></a>00258 
<a name="l00259"></a>00259 <span class="preprocessor">#else</span>
<a name="l00260"></a>00260 <span class="preprocessor"></span>
<a name="l00261"></a>00261 <span class="comment">/* TODO: remove this section after sufficient testing */</span>
<a name="l00262"></a>00262 
<a name="l00263"></a>00263 <span class="preprocessor">#ifdef UNIPROC</span>
<a name="l00264"></a>00264 <span class="preprocessor"></span>  VecPlaceArray(gdata-&gt;<a class="code" href="structGridData.html#aa8ed194b67f1446b9c299028c1ed0692">M</a>,NV_DATA_S(<a class="code" href="mytscreatepvode_8c.html#a293e1df257c757d729d4b0200626e31a">nvu</a>));
<a name="l00265"></a>00265 <span class="preprocessor">#else</span>
<a name="l00266"></a>00266 <span class="preprocessor"></span>  VecPlaceArray(gdata-&gt;<a class="code" href="structGridData.html#aa8ed194b67f1446b9c299028c1ed0692">M</a>,NV_DATA_P(<a class="code" href="mytscreatepvode_8c.html#a293e1df257c757d729d4b0200626e31a">nvu</a>));
<a name="l00267"></a>00267 <span class="preprocessor">#endif</span>
<a name="l00268"></a>00268 <span class="preprocessor"></span>
<a name="l00269"></a>00269   <span class="comment">/* renormalize M since we just reinitialized PVODE */</span>
<a name="l00270"></a>00270   <a class="code" href="renormvec_8c.html#abba3d002260d6e3e062ac69a80300aa4">RenormVec</a>(gdata-&gt;<a class="code" href="structGridData.html#aa8ed194b67f1446b9c299028c1ed0692">M</a>,1.0,<a class="code" href="griddata_8h.html#a26ab586dda1b8c780aa849e457c0cbad">D_EPS</a>,<a class="code" href="griddata_8h.html#a68d169e5b90cf721678bc7ab0f964a99">ND</a>);
<a name="l00271"></a>00271 
<a name="l00272"></a>00272   ierr=VecResetArray(gdata-&gt;<a class="code" href="structGridData.html#aa8ed194b67f1446b9c299028c1ed0692">M</a>);
<a name="l00273"></a>00273 <span class="preprocessor">#endif</span>
<a name="l00274"></a>00274 <span class="preprocessor"></span>
<a name="l00275"></a>00275   PetscInfo1(0,<span class="stringliteral">&quot;t=%g ns: renormalized M\n&quot;</span>,gdata-&gt;<a class="code" href="structGridData.html#a9eb9246406e97a2a4a8a9c471b11aa2a">time</a>*gdata-&gt;<a class="code" href="structGridData.html#ad7a22de0cb266e66e8dbcb1bb147bae8">tscale</a>*1e9);
<a name="l00276"></a>00276 
<a name="l00277"></a>00277   <span class="keywordtype">int</span> flag;
<a name="l00278"></a>00278 
<a name="l00279"></a>00279 <span class="preprocessor">#undef RESETDTIME</span>
<a name="l00280"></a>00280 <span class="preprocessor"></span><span class="preprocessor">#ifdef RESETDTIME</span>
<a name="l00281"></a>00281 <span class="preprocessor"></span>  realtype dtime;
<a name="l00282"></a>00282   flag=CVodeGetCurrentStep(<a class="code" href="mytscreatepvode_8c.html#a809fb699daf418600ff788f3826954c9">cvode_mem</a>,&amp;dtime);
<a name="l00283"></a>00283 <span class="preprocessor">#endif</span>
<a name="l00284"></a>00284 <span class="preprocessor"></span>
<a name="l00285"></a>00285   flag =
<a name="l00286"></a>00286     CVodeReInit(
<a name="l00287"></a>00287       <a class="code" href="mytscreatepvode_8c.html#a809fb699daf418600ff788f3826954c9">cvode_mem</a>,
<a name="l00288"></a>00288       <a class="code" href="rhsfunction_8c.html#a5e964b5572e1640d9a793c353f6a28f6">RHSfunction</a>,
<a name="l00289"></a>00289       gdata-&gt;<a class="code" href="structGridData.html#a9eb9246406e97a2a4a8a9c471b11aa2a">time</a>,
<a name="l00290"></a>00290       <a class="code" href="mytscreatepvode_8c.html#a293e1df257c757d729d4b0200626e31a">nvu</a>,
<a name="l00291"></a>00291       CV_SS,
<a name="l00292"></a>00292       <a class="code" href="checkiterationllg_8c.html#a29c891f86d4e498ef78fe8d82ac95ea6">reltol</a>,
<a name="l00293"></a>00293       &amp;<a class="code" href="checkiterationllg_8c.html#aec51da788a337a7317e3b25e8a634716">abstol</a>
<a name="l00294"></a>00294     );
<a name="l00295"></a>00295   <span class="keywordflow">if</span> (flag != CV_SUCCESS) {
<a name="l00296"></a>00296     SETERRQ1(PETSC_ERR_LIB,<span class="stringliteral">&quot;CVodeReInit failed: %i\n&quot;</span>, flag);
<a name="l00297"></a>00297   }
<a name="l00298"></a>00298   PetscInfo(0,<span class="stringliteral">&quot;PVODE successfully reinitialized\n&quot;</span>);
<a name="l00299"></a>00299 
<a name="l00300"></a>00300 <span class="preprocessor">#ifdef RESETDTIME</span>
<a name="l00301"></a>00301 <span class="preprocessor"></span>  flag=CVodeSetInitStep(<a class="code" href="mytscreatepvode_8c.html#a809fb699daf418600ff788f3826954c9">cvode_mem</a>,dtime);
<a name="l00302"></a>00302 <span class="preprocessor">#endif</span>
<a name="l00303"></a>00303 <span class="preprocessor"></span>
<a name="l00304"></a>00304   <a class="code" href="griddata_8h.html#a9a4d090c28602d7ff7ec883fb6f413db">MagparFunctionProfReturn</a>(0);
<a name="l00305"></a>00305 }
<a name="l00306"></a>00306 
<a name="l00307"></a>00307 
<a name="l00308"></a><a class="code" href="mytscreatepvode_8c.html#a9671ea286af405e584ae7468a0ce15b3">00308</a> <span class="keywordtype">int</span> <a class="code" href="mytscreatepvode_8c.html#a9671ea286af405e584ae7468a0ce15b3">myTSCreatePVode</a>(<a class="code" href="structGridData.html">GridData</a> *gdata)
<a name="l00309"></a>00309 {
<a name="l00310"></a>00310   PetscTruth flg;
<a name="l00311"></a>00311 
<a name="l00312"></a>00312   <a class="code" href="griddata_8h.html#a3d9da926137619fd02adb245a08536c7">MagparFunctionLogBegin</a>;
<a name="l00313"></a>00313 
<a name="l00314"></a>00314   <span class="keywordtype">int</span> rank,size;
<a name="l00315"></a>00315   ierr = MPI_Comm_size(PETSC_COMM_WORLD,&amp;size);CHKERRQ(ierr);
<a name="l00316"></a>00316   ierr = MPI_Comm_rank(PETSC_COMM_WORLD,&amp;rank);CHKERRQ(ierr);
<a name="l00317"></a>00317 
<a name="l00318"></a>00318   ierr = PetscOptionsGetReal(PETSC_NULL,<span class="stringliteral">&quot;-ts_pvode_rtol&quot;</span>,&amp;<a class="code" href="checkiterationllg_8c.html#a29c891f86d4e498ef78fe8d82ac95ea6">reltol</a>,  &amp;flg);CHKERRQ(ierr);
<a name="l00319"></a>00319   <span class="keywordflow">if</span> (flg!=PETSC_TRUE) {
<a name="l00320"></a>00320     <a class="code" href="checkiterationllg_8c.html#a29c891f86d4e498ef78fe8d82ac95ea6">reltol</a>=1e-6;
<a name="l00321"></a>00321     PetscPrintf(PETSC_COMM_WORLD,
<a name="l00322"></a>00322       <span class="stringliteral">&quot;Option -ts_pvode_rtol not found, using default value: %g\n&quot;</span>,
<a name="l00323"></a>00323       <a class="code" href="checkiterationllg_8c.html#a29c891f86d4e498ef78fe8d82ac95ea6">reltol</a>
<a name="l00324"></a>00324     );
<a name="l00325"></a>00325   }
<a name="l00326"></a>00326   PetscPrintf(PETSC_COMM_WORLD,<span class="stringliteral">&quot;reltol:      %g\n&quot;</span>,<a class="code" href="checkiterationllg_8c.html#a29c891f86d4e498ef78fe8d82ac95ea6">reltol</a>);
<a name="l00327"></a>00327 
<a name="l00328"></a>00328   ierr = PetscOptionsGetReal(PETSC_NULL,<span class="stringliteral">&quot;-ts_pvode_atol&quot;</span>,&amp;<a class="code" href="checkiterationllg_8c.html#aec51da788a337a7317e3b25e8a634716">abstol</a>,  &amp;flg);CHKERRQ(ierr);
<a name="l00329"></a>00329   <span class="keywordflow">if</span> (flg!=PETSC_TRUE) {
<a name="l00330"></a>00330     <a class="code" href="checkiterationllg_8c.html#aec51da788a337a7317e3b25e8a634716">abstol</a>=1e-6;
<a name="l00331"></a>00331     PetscPrintf(PETSC_COMM_WORLD,
<a name="l00332"></a>00332       <span class="stringliteral">&quot;Option -ts_pvode_atol not found, using default value: %g\n&quot;</span>,
<a name="l00333"></a>00333       <a class="code" href="checkiterationllg_8c.html#aec51da788a337a7317e3b25e8a634716">abstol</a>
<a name="l00334"></a>00334     );
<a name="l00335"></a>00335   }
<a name="l00336"></a>00336   PetscPrintf(PETSC_COMM_WORLD,<span class="stringliteral">&quot;abstol:      %g\n&quot;</span>,<a class="code" href="checkiterationllg_8c.html#aec51da788a337a7317e3b25e8a634716">abstol</a>);
<a name="l00337"></a>00337 
<a name="l00338"></a>00338   <span class="keywordtype">int</span> neq, local_N;
<a name="l00339"></a>00339   ierr = VecGetSize(gdata-&gt;<a class="code" href="structGridData.html#aa8ed194b67f1446b9c299028c1ed0692">M</a>,(<a class="code" href="griddata_8h.html#a515706180f960b30595b607f2d734d14" title="Contains all data to control the simulations.">PetscInt</a>*)&amp;neq);CHKERRQ(ierr);
<a name="l00340"></a>00340   ierr = VecGetLocalSize(gdata-&gt;<a class="code" href="structGridData.html#aa8ed194b67f1446b9c299028c1ed0692">M</a>,(<a class="code" href="griddata_8h.html#a515706180f960b30595b607f2d734d14" title="Contains all data to control the simulations.">PetscInt</a>*)&amp;local_N);CHKERRQ(ierr);
<a name="l00341"></a>00341 
<a name="l00342"></a>00342   assert(neq==<a class="code" href="griddata_8h.html#a68d169e5b90cf721678bc7ab0f964a99">ND</a>*gdata-&gt;<a class="code" href="structGridData.html#a170b7b2a45022cc3d4aaee232844e50c">n_vert</a>);
<a name="l00343"></a>00343   assert(local_N==<a class="code" href="griddata_8h.html#a68d169e5b90cf721678bc7ab0f964a99">ND</a>*gdata-&gt;<a class="code" href="structGridData.html#ae08e5326571671a361ae5d761d6ca672">ln_vert</a>);
<a name="l00344"></a>00344 
<a name="l00345"></a>00345 <span class="preprocessor">#ifdef UNIPROC</span>
<a name="l00346"></a>00346 <span class="preprocessor"></span>  <a class="code" href="mytscreatepvode_8c.html#a293e1df257c757d729d4b0200626e31a">nvu</a>=N_VNew_Serial(neq);
<a name="l00347"></a>00347 <span class="preprocessor">#else</span>
<a name="l00348"></a>00348 <span class="preprocessor"></span>  <a class="code" href="mytscreatepvode_8c.html#a293e1df257c757d729d4b0200626e31a">nvu</a>=N_VNew_Parallel(PETSC_COMM_WORLD,local_N,neq);
<a name="l00349"></a>00349 <span class="preprocessor">#endif</span>
<a name="l00350"></a>00350 <span class="preprocessor"></span>
<a name="l00351"></a>00351   <span class="comment">/* create new vector with PVODE&#39;s array */</span>
<a name="l00352"></a>00352   <span class="comment">/* real data must be of same type as PETSc data (usually double) !!! */</span>
<a name="l00353"></a>00353   Vec  Mnew;
<a name="l00354"></a>00354   ierr = VecCreateMPIWithArray(
<a name="l00355"></a>00355     PETSC_COMM_WORLD,
<a name="l00356"></a>00356     local_N,
<a name="l00357"></a>00357     neq,
<a name="l00358"></a>00358 #ifdef UNIPROC
<a name="l00359"></a>00359     NV_DATA_S(<a class="code" href="mytscreatepvode_8c.html#a293e1df257c757d729d4b0200626e31a">nvu</a>),
<a name="l00360"></a>00360 #<span class="keywordflow">else</span>
<a name="l00361"></a>00361     NV_DATA_P(<a class="code" href="mytscreatepvode_8c.html#a293e1df257c757d729d4b0200626e31a">nvu</a>),
<a name="l00362"></a>00362 #endif
<a name="l00363"></a>00363     &amp;Mnew
<a name="l00364"></a>00364   );CHKERRQ(ierr);
<a name="l00365"></a>00365 
<a name="l00366"></a>00366   <span class="comment">/* copy current magnetization distribution into the new vector */</span>
<a name="l00367"></a>00367   VecCopy(gdata-&gt;<a class="code" href="structGridData.html#aa8ed194b67f1446b9c299028c1ed0692">M</a>,Mnew);
<a name="l00368"></a>00368   VecDestroy(gdata-&gt;<a class="code" href="structGridData.html#aa8ed194b67f1446b9c299028c1ed0692">M</a>);
<a name="l00369"></a>00369   gdata-&gt;<a class="code" href="structGridData.html#aa8ed194b67f1446b9c299028c1ed0692">M</a>=Mnew;
<a name="l00370"></a>00370   ierr = VecSetBlockSize(gdata-&gt;<a class="code" href="structGridData.html#aa8ed194b67f1446b9c299028c1ed0692">M</a>,<a class="code" href="griddata_8h.html#a68d169e5b90cf721678bc7ab0f964a99">ND</a>);CHKERRQ(ierr);
<a name="l00371"></a>00371 
<a name="l00372"></a>00372   <a class="code" href="mytscreatepvode_8c.html#a809fb699daf418600ff788f3826954c9">cvode_mem</a>=NULL;
<a name="l00373"></a>00373 
<a name="l00374"></a>00374   <span class="comment">/* initialize PVode */</span>
<a name="l00375"></a>00375   ierr = <a class="code" href="mytscreatepvode_8c.html#a56b55de0386618edfef4220e5b7b078a">PVodeInit</a>(gdata);CHKERRQ(ierr);
<a name="l00376"></a>00376 
<a name="l00377"></a>00377   <a class="code" href="griddata_8h.html#a8491466d8534a33d7163f5ea747e8210">MagparFunctionLogReturn</a>(0);
<a name="l00378"></a>00378 }
<a name="l00379"></a>00379 
</pre></div></div>
  <hr>
  <address>
    magpar - Parallel Finite Element Micromagnetics Package<br>
    Copyright (C) 2002-2010 Werner Scholz
  </address>
  </body>
</html>

